﻿veh = {}
ExitTimer = {}
function TakePlayerMoney(player,money)
	takePlayerMoney(player,money)
end
addEvent("TakePlayerMoney",true)
addEventHandler("TakePlayerMoney",getRootElement(),TakePlayerMoney,player,money)

function playerLogin (previous_acc, theCurrentAccount)
    local VehLicenseAcc = getAccountData (theCurrentAccount, "VehLicense")
	local VehLicenseStudyAcc = getAccountData (theCurrentAccount, "VehLevel")
	local PlaneLicenseAcc = getAccountData (theCurrentAccount, "PlaneLicense")
	local BoatLicenseAcc = getAccountData (theCurrentAccount, "BoatLicense")
	local BikeLicenseAcc = getAccountData (theCurrentAccount, "BikeLicense")
	local WeapLicenseAcc = getAccountData (theCurrentAccount, "WeapLicense")
    if (VehLicenseAcc) then
	  setElementData(source, "VehLicense", VehLicenseAcc)
	  setElementData(source, "VehLevel", VehLicenseStudyAcc)
	  setElementData(source, "PlaneLicense", PlaneLicenseAcc)
	  setElementData(source, "BoatLicense", BoatLicenseAcc)
	  setElementData(source, "BikeLicense", BikeLicenseAcc)
	  setElementData(source, "WeapLicense", WeapLicenseAcc)
	end
end
addEventHandler ("onPlayerLogin", getRootElement(), playerLogin)

function Save (account)
	  local VehLicense = getElementData(source, "VehLicense") or false
	  local VehLicenseStudy = getElementData(source, "VehLevel") or 0
	  local PlaneLicense = getElementData(source, "PlaneLicense") or false
	  local BoatLicense = getElementData(source, "BoatLicense") or false
	  local BikeLicense = getElementData(source, "BikeLicense") or false
	  local WeapLicense = getElementData(source, "WeapLicense") or false
	  setAccountData (account, "VehLicense", VehLicense)
	  setAccountData (account, "VehLevel", VehLicenseStudy)
	  setAccountData (account, "PlaneLicense", PlaneLicense)
	  setAccountData (account, "BoatLicense", BoatLicense)
	  setAccountData (account, "BikeLicense", BoatLicense)
	  setAccountData (account, "WeapLicense", WeapLicense)
end
	
function onQuit()
	account = getPlayerAccount (source)
    if (account) then
	Save(account)
	end
end
addEventHandler ("onPlayerQuit", getRootElement(), onQuit)

function onLogout(previous_acc)
    if (previous_acc) then
	Save(previous_acc)
	end
end
addEventHandler ("onPlayerLogout", getRootElement(), onLogout)
addEventHandler ("onResourceStop", getRootElement(), onQuit)

--- Проверка лицензий игрока
boats = { [430] = true, [446] = true, [452] = true, [453] = true, [454] = true, [472] = true, [473] = true, [484] = true, [493] = true, [595] = true }
aero = { [417] = true, [425] = true, [447] = true, [460] = true, [469] = true, [476] = true, [487] = true, [488] = true, [497] = true, [511] = true, [512] = true, [513] = true, [519] = true, [520] = true, [548] = true, [553] = true, [563] = true, [577] = true, [592] = true, [593] = true }  
noNeedModels = { 448, 510, 462, 509, 481 } -- модели авто, которым не нужны права
BikeModels = { [522] = true, [521] = true, [461] = true, [463] = true, [586] = true, [581] = true, [468] = true, [471] = true, [523] = true  }
function isVehicleNoNeed (model)
	for i, v in ipairs ( noNeedModels ) do
		if v == model then
			return true
		end
	end
	return false
end	

function enterVehicle ( thePlayer, seat, jacked )
	if seat == 0 then
		if ( boats[getElementModel ( source )] ) and ( not getElementData ( thePlayer, "BoatLicense" ) ) and isElement( thePlayer ) and getElementType( thePlayer ) == "player" then
			outputChatBox ( "У вас нет лицензии на вождение водного транспорта.", thePlayer, 255, 100, 100 )
			setControlState ( thePlayer, "enter_exit", true )
		elseif ( aero[getElementModel ( source )] ) and ( not getElementData ( thePlayer, "PlaneLicense" ) ) and isElement( thePlayer ) and getElementType( thePlayer ) == "player" then
			outputChatBox ( "У вас нет лицензии на управление воздушным транспортом.", thePlayer, 255, 100, 100 )
			setControlState ( thePlayer, "enter_exit", true )
		elseif ( BikeModels[getElementModel ( source )] ) and ( not getElementData ( thePlayer, "BikeLicense" ) ) and isElement( thePlayer ) and getElementType( thePlayer ) == "player" then
			outputChatBox ( "У вас нет лицензии на управление мотоциклом.", thePlayer, 255, 100, 100 )
			setControlState ( thePlayer, "enter_exit", true )
		elseif getElementData( thePlayer, "Study" ) == true  and getElementModel ( source ) == 562 and isElement( thePlayer ) and getElementType( thePlayer ) == "player" then
			if isTimer(ExitTimer[thePlayer]) then
				killTimer(ExitTimer[thePlayer])
			end
		elseif getElementData( thePlayer, "Study" ) == true  and getElementModel ( source ) == 411 and isElement( thePlayer ) and getElementType( thePlayer ) == "player"  then
			if isTimer(ExitTimer[thePlayer]) then
				killTimer(ExitTimer[thePlayer])
			end
		elseif ( not getElementData ( thePlayer, "VehLicense" ) and not isVehicleNoNeed ( getElementModel ( source )) ) and isElement( thePlayer ) and getElementType( thePlayer ) == "player" then
			outputChatBox ( "У вас нет лицензии на вождение автомобиля.", thePlayer, 255, 100, 100 )
			setControlState ( thePlayer, "enter_exit", true )
		end
	end
end
addEventHandler ( "onVehicleEnter", getRootElement(), enterVehicle ) 

function exitVehicle ( thePlayer, seat, jacked )
	if seat == 0 and getElementData( thePlayer, "Study" ) == true and (getElementModel ( source ) == 562 or 411) and isElement( thePlayer ) and getElementType( thePlayer ) == "player"  then
		ExitTimer[thePlayer] = setTimer(abortStudy, 15000, 0, thePlayer)
		outputChatBox ( "У вас есть 15 секунд чтобы вернуться в машину.", thePlayer, 255, 100, 100 )
	end
end
addEventHandler ( "onVehicleExit", getRootElement(), exitVehicle ) 

function abortStudy(cPlayer)
	killTimer(ExitTimer[cPlayer])
	triggerClientEvent ( cPlayer, "EndStudy", cPlayer)
end
-- Показать лицензии

function showLicToPlayer ( player, cmd, name )
	if name then
		local target = getPlayerFromName ( name )
		if target then
			outputChatBox ( "Вы показали свои лицензии игроку "..getPlayerName ( target ), player, 50, 255, 50 )
			outputChatBox ( getPlayerName ( player ).." показал вам свои лицензии", target, 50, 255, 50 )
			triggerClientEvent ( target, "showLicenses", target, getPlayerName ( player ), getElementData ( player, "VehLicense" ), getElementData ( player, "PlaneLicense" ), getElementData ( player, "BoatLicense" ),getElementData ( player, "BikeLicense" ),getElementData ( player, "WeapLicense" ) )
		else
			outputChatBox ( "Игрок не найден", player, 255, 150, 140 )
		end
	else
		triggerClientEvent ( player, "showLicenses", player, getPlayerName ( player ), getElementData ( player, "VehLicense" ), getElementData ( player, "PlaneLicense" ), getElementData ( player, "BoatLicense" ),getElementData ( player, "BikeLicense" ),getElementData ( player, "WeapLicense" ) )
	end
end
addCommandHandler ("showlic", showLicToPlayer )

-- Полигон
function StartPoly(cPlayer)
	setElementData(cPlayer, "Study", true)
	veh[cPlayer] = createVehicle ( 562, -2078, -121, 35.32, 0, 0, -90 )
	warpPedIntoVehicle ( cPlayer, veh[cPlayer], 0 )
end
addEvent("StartPoly",true)
addEventHandler("StartPoly",getRootElement(),StartPoly,cPlayer)
function EndPoly(cPlayer)
	destroyElement(veh[cPlayer])
	setElementData(cPlayer, "Study", false)
end
addEvent("EndPoly",true)
addEventHandler("EndPoly",getRootElement(),EndPoly,cPlayer)

function StartCity(cPlayer)
	setElementData(cPlayer, "Study", true)
	veh[cPlayer] = createVehicle ( 411, -2068.65, -84, 35.32, 0, 0, 180 )
	warpPedIntoVehicle ( cPlayer, veh[cPlayer], 0 )
end
addEvent("StartCity",true)
addEventHandler("StartCity",getRootElement(),StartCity,cPlayer)
function EndCity(cPlayer)
	destroyElement(veh[cPlayer])
	setElementData(cPlayer, "Study", false)
end
addEvent("EndCity",true)
addEventHandler("EndCity",getRootElement(),EndCity,cPlayer)